/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "input.h"
#include "assert/assert.h"

input_t INPUT;

bool_t inputIsDown(const uint8_t key) {
  assertTrue(key < INPUT_COUNT, "Invalid input key");
  return (INPUT.current & key) != 0;
}

bool_t inputWasDown(const uint8_t key) {
  assertTrue(key < INPUT_COUNT, "Invalid input key");
  return (INPUT.previous & key) != 0;
}

bool_t inputWasPressed(const uint8_t key) {
  return inputIsDown(key) && !inputWasDown(key);
}

bool_t inputWasReleased(const uint8_t key) {
  return !inputIsDown(key) && inputWasDown(key);
}