/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "input.h"
#include "util/random.h"
#include "display/render.h"

#include "rpg/entity/entity.h"
#include "rpg/world/maps/testmap.h"

int32_t main(const int32_t argc, const char **argv) {
  inputInit();
  randomInit();
  renderInit();
  
  mapSet(TEST_MAP);

  while(1) {
    inputUpdate();
    mapUpdate();
    if(!renderUpdate()) break;
  }

  return EXIT_SUCCESS;
}