/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "entity.h"
#include "assert/assert.h"

void npcInit(entity_t *ent) {
  assertNotNull(ent, "NPC entity is NULL");
  assertTrue(ent->type == ENTITY_TYPE_NPC, "Entity is not an NPC");
}

void npcUpdate(entity_t *ent) {
  assertNotNull(ent, "Entity is NULL");
  assertTrue(ent->type == ENTITY_TYPE_NPC, "Entity is not an NPC");
}

bool_t npcInteract(entity_t *self, entity_t *player) {
  assertNotNull(self, "NPC entity cannot be NULL");
  assertNotNull(player, "Player entity cannot be NULL");
  assertTrue(self->type == ENTITY_TYPE_NPC, "Entity is not an NPC");
  assertTrue(player->type == ENTITY_TYPE_PLAYER, "Entity is not a player");

  // Look at the player
  entityTurn(self, entityGetLookDirection(self, player->x, player->y));
  
  return true;
}