/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct _entity_t entity_t;

typedef struct {
  uint8_t nothing; // Placeholder for NPC-specific data
} npc_t;

/**
 * Initializes an NPC entity.
 * 
 * @param ent Pointer to the NPC entity to initialize.
 */
void npcInit(entity_t *ent);

/**
 * Updates an NPC entity.
 * 
 * @param ent Entity to update.
 */
void npcUpdate(entity_t *ent);

/**
 * Handles interaction between an NPC and a player.
 * 
 * @param self Pointer to the NPC entity.
 * @param player Pointer to the player entity interacting with the NPC.
 */
bool_t npcInteract(entity_t *self, entity_t *player);