/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "itemstack.h"

#define INVENTORY_ITEM_COUNT 32

typedef struct {
  itemstack_t items[INVENTORY_ITEM_COUNT];
  uint8_t itemCount;
} inventory_t;

/**
 * Initializes the inventory.
 * 
 * @param inventory Pointer to the inventory to initialize.
 */
void inventoryInit(inventory_t *inventory);