/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef enum {
  ITEM_TYPE_NULL,

  // Consumables
  ITEM_TYPE_POTION,

  // Ingredients
  ITEM_TYPE_ONION,
  ITEM_TYPE_SWEET_POTATO,

  // Cooked Items
  ITEM_TYPE_BAKED_SWEET_POTATO,
} itemtype_t;

#define ITEM_TYPE_COUNT (ITEM_TYPE_BAKED_SWEET_POTATO + 1)

typedef struct {
  bool_t stackable;
} iteminfo_t;
extern iteminfo_t ITEM_INFO[ITEM_TYPE_COUNT];

/**
 * Returns true if the item type is stackable.
 * 
 * @param type The item type to check.
 * @return true if the item type is stackable, false otherwise.
 */
static inline bool_t itemTypeIsStackable(const itemtype_t type);