/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "rpg/entity/entity.h"
#include "rpg/world/map.h"

/**
 * Initializes the test map.
 * 
 * This function sets up a test map with predefined dimensions.
 */
void testMapInit() {
  mapInit(10, 10);

  entity_t *ent = MAP.entities;
  entityInit(ent, ENTITY_TYPE_PLAYER);

  ent++;
  entityInit(ent, ENTITY_TYPE_NPC);
  entityPositionSet(ent, 5, 5);
}

mapinfo_t TEST_MAP = {
  .name = "Test Map",
  .init = testMapInit
};